function varargout = VirtualEPR(varargin)
% VIRTUALEPR M-file for VirtualEPR.fig
%      VIRTUALEPR, by itself, creates a new VIRTUALEPR or raises the existing
%      singleton*.
%
%      H = VIRTUALEPR returns the handle to a new VIRTUALEPR or the handle to
%      the existing singleton*.
%
%      VIRTUALEPR('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in VIRTUALEPR.M with the given input arguments.
%
%      VIRTUALEPR('Property','Value',...) creates a new VIRTUALEPR or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before VirtualEPR_OpeningFunction gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to VirtualEPR_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help VirtualEPR

% Last Modified by GUIDE v2.5 01-Nov-2006 14:50:29

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @VirtualEPR_OpeningFcn, ...
                   'gui_OutputFcn',  @VirtualEPR_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before VirtualEPR is made visible.
function VirtualEPR_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to VirtualEPR (see VARARGIN)

% Choose default command line output for VirtualEPR
handles.output = hObject;

% initialize the input parameters

handles.CF=340; % initialize center field (mT)
handles.SW=10; % initialize sweep width (mT)
handles.attn=20; % initialize MW attenuation (dB)
handles.modamp=0.1; % initialize modulation amplitude (mT)
handles.gain=10; % initialize receiver gain
handles.points=512; % initialize number of data points
handles.scans=1;

% initialize parameter bounds and defaults
handles.CF_default=handles.CF;
handles.CF_min=20;
handles.CF_max=450;
handles.SW_default=handles.SW;
handles.SW_min=0.1;
handles.SW_max=handles.CF_max-handles.CF_min;
handles.attn_default=handles.attn;
handles.attn_min=0;
handles.attn_max=60;
handles.modamp_default=handles.modamp;
handles.modamp_min=1e-3;
handles.modamp_max=5;
handles.gain_default=10;
handles.gain_min=1;
handles.gain_max=10000;
handles.points_default=handles.points;
handles.points_min=16;
handles.points_max=4096;
handles.scans_default=handles.scans;
handles.scans_min=1;
handles.scans_max=100;

% initialize hidden spectrometer parameters

handles.ny=9.6; % spectrometer frequency in GHz
handles.power=200; % m.w. power at 0 dB attenuation in mW
handles.modfrq=0.1; % modulation frequency in MHz
handles.power_conversion=0.05; % m.w. field amplitude in mT at 0 dB
handles.noise=0.5; % noise level
handles.internalGain=1; % internal signal gain
handles.mod_calib=0.2/0.36986;

set(hObject,'Name',sprintf('VirtualEPR at %4.2f GHz',handles.ny));

% initialize sample parameters

handles.T1=1; % T1 (usec)
handles.T2=1; % T2 (usec)
handles.g=2.002319; % g value

% initialize spectrum
handles.b0=linspace(handles.CF-handles.SW/2,handles.CF+handles.SW/2,handles.points);
handles.spec=zeros(size(handles.b0));

% Update handles structure
guidata(hObject, handles);

% UIWAIT makes VirtualEPR wait for user response (see UIRESUME)
% uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = VirtualEPR_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;


% --- Executes on button press in close_button.
function close_button_Callback(hObject, eventdata, handles)
% hObject    handle to close_button (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

close(handles.main_window);

% --- Executes on button press in save_button.
function save_button_Callback(hObject, eventdata, handles)
% hObject    handle to save_button (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

data=[handles.b0' handles.spec'];
[fname,pname]=uiputfile('*.dat','Save current spectrum');
fname=strtok(fname,'.');
fullname=[pname fname '.dat'];
save(fullname,'data','-ascii');

% --- Executes on button press in run_button.
function run_button_Callback(hObject, eventdata, handles)
% hObject    handle to run_button (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

handles=run_CW_spec(handles);
handles=get_characteristics(handles);
% Update handles structure
guidata(hObject, handles);

function center_field_Callback(hObject, eventdata, handles)
% hObject    handle to center_field (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of center_field as text
%        str2double(get(hObject,'String')) returns contents of center_field as a double

[v,handles]=edit_update(handles,hObject,handles.CF_min,handles.CF_max,handles.CF_default,'%6.2f',0);
handles.CF=v;
% Update handles structure
guidata(hObject, handles);

% --- Executes during object creation, after setting all properties.
function center_field_CreateFcn(hObject, eventdata, handles)
% hObject    handle to center_field (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function sweep_width_Callback(hObject, eventdata, handles)
% hObject    handle to sweep_width (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of sweep_width as text
%        str2double(get(hObject,'String')) returns contents of sweep_width as a double

[v,handles]=edit_update(handles,hObject,handles.SW_min,handles.SW_max,handles.SW_default,'%6.2f',0);
handles.SW=v;
% Update handles structure
guidata(hObject, handles);


% --- Executes during object creation, after setting all properties.
function sweep_width_CreateFcn(hObject, eventdata, handles)
% hObject    handle to sweep_width (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function mw_attn_Callback(hObject, eventdata, handles)
% hObject    handle to mw_attn (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of mw_attn as text
%        str2double(get(hObject,'String')) returns contents of mw_attn as a double

[v,handles]=edit_update(handles,hObject,handles.attn_min,handles.attn_max,handles.attn_default,'%i',1);
handles.attn=v;
power=10^(-v/10)*handles.power;
unitstr='mW';
if power>=100,
    powstr=sprintf('%4.0f',power);
elseif power>=10,
    powstr=sprintf('%4.1f',power);
elseif power>=1,
    powstr=sprintf('%4.2f',power);
elseif power>=0.1,
    powstr=sprintf('%4.0f',1000*power);
    unitstr='uW';
elseif power>=0.01,
    powstr=sprintf('%4.1f',1000*power);
    unitstr='uW';
elseif power>=0.001,
    powstr=sprintf('%4.2f',1000*power);
    unitstr='uW';
elseif power>=0.0001,
    powstr=sprintf('%4.0f',1000000*power);
    unitstr='nW';
elseif power>=0.00001,
    powstr=sprintf('%4.1f',1000000*power);
    unitstr='nW';
else
    powstr=sprintf('%4.2f',1000000*power);
    unitstr='nW';
end;
set(handles.text_power,'String',powstr);
set(handles.text_power_unit,'String',unitstr);
% Update handles structure
guidata(hObject, handles);



% --- Executes during object creation, after setting all properties.
function mw_attn_CreateFcn(hObject, eventdata, handles)
% hObject    handle to mw_attn (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in mw_attn_up.
function mw_attn_up_Callback(hObject, eventdata, handles)
% hObject    handle to mw_attn_up (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

attn=handles.attn+3;
if attn<=handles.attn_max,
    handles.attn=attn;
    pstr=sprintf('%i',handles.attn);
    set(handles.mw_attn,'String',pstr);
else,
    handles.attn=handles.attn_max;
    pstr=sprintf('%i',handles.attn);
    set(handles.mw_attn,'String',pstr);
end;
power=10^(-handles.attn/10)*handles.power;
unitstr='mW';
if power>=100,
    powstr=sprintf('%4.0f',power);
elseif power>=10,
    powstr=sprintf('%4.1f',power);
elseif power>=1,
    powstr=sprintf('%4.2f',power);
elseif power>=0.1,
    powstr=sprintf('%4.0f',1000*power);
    unitstr='uW';
elseif power>=0.01,
    powstr=sprintf('%4.1f',1000*power);
    unitstr='uW';
elseif power>=0.001,
    powstr=sprintf('%4.2f',1000*power);
    unitstr='uW';
elseif power>=0.0001,
    powstr=sprintf('%4.0f',1000000*power);
    unitstr='nW';
elseif power>=0.00001,
    powstr=sprintf('%4.1f',1000000*power);
    unitstr='nW';
else
    powstr=sprintf('%4.2f',1000000*power);
    unitstr='nW';
end;
set(handles.text_power,'String',powstr);
set(handles.text_power_unit,'String',unitstr);
% Update handles structure
guidata(hObject, handles);


% --- Executes on button press in mw_attn_down.
function mw_attn_down_Callback(hObject, eventdata, handles)
% hObject    handle to mw_attn_down (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

attn=handles.attn-3;
if attn>=handles.attn_min,
    handles.attn=attn;
    pstr=sprintf('%i',handles.attn);
    set(handles.mw_attn,'String',pstr);
else,
    handles.attn=handles.attn_min;
    pstr=sprintf('%i',handles.attn);
    set(handles.mw_attn,'String',pstr);
end;
power=10^(-handles.attn/10)*handles.power;
unitstr='mW';
if power>=100,
    powstr=sprintf('%4.0f',power);
elseif power>=10,
    powstr=sprintf('%4.1f',power);
elseif power>=1,
    powstr=sprintf('%4.2f',power);
elseif power>=0.1,
    powstr=sprintf('%4.0f',1000*power);
    unitstr='uW';
elseif power>=0.01,
    powstr=sprintf('%4.1f',1000*power);
    unitstr='uW';
elseif power>=0.001,
    powstr=sprintf('%4.2f',1000*power);
    unitstr='uW';
elseif power>=0.0001,
    powstr=sprintf('%4.0f',1000000*power);
    unitstr='nW';
elseif power>=0.00001,
    powstr=sprintf('%4.1f',1000000*power);
    unitstr='nW';
else
    powstr=sprintf('%4.2f',1000000*power);
    unitstr='nW';
end;
set(handles.text_power,'String',powstr);
set(handles.text_power_unit,'String',unitstr);
% Update handles structure
guidata(hObject, handles);

function mod_amp_Callback(hObject, eventdata, handles)
% hObject    handle to mod_amp (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of mod_amp as text
%        str2double(get(hObject,'String')) returns contents of mod_amp as a double

[v,handles]=edit_update(handles,hObject,handles.modamp_min,handles.modamp_max,handles.modamp_default,'%7.3f',0);
handles.modamp=v;
% Update handles structure
guidata(hObject, handles);


% --- Executes during object creation, after setting all properties.
function mod_amp_CreateFcn(hObject, eventdata, handles)
% hObject    handle to mod_amp (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function rec_gain_Callback(hObject, eventdata, handles)
% hObject    handle to rec_gain (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of rec_gain as text
%        str2double(get(hObject,'String')) returns contents of rec_gain as a double

[v,handles]=edit_update(handles,hObject,handles.gain_min,handles.gain_max,handles.gain_default,'%5.0f',0);
handles.gain=v;
% Update handles structure
guidata(hObject, handles);


% --- Executes during object creation, after setting all properties.
function rec_gain_CreateFcn(hObject, eventdata, handles)
% hObject    handle to rec_gain (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end





function num_points_Callback(hObject, eventdata, handles)
% hObject    handle to num_points (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of num_points as text
%        str2double(get(hObject,'String')) returns contents of num_points as a double

[v,handles]=edit_update(handles,hObject,handles.points_min,handles.points_max,handles.points_default,'%4.0f',1);
handles.points=v;
% Update handles structure
guidata(hObject, handles);


% --- Executes during object creation, after setting all properties.
function num_points_CreateFcn(hObject, eventdata, handles)
% hObject    handle to num_points (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end





function num_scans_Callback(hObject, eventdata, handles)
% hObject    handle to num_scans (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of num_scans as text
%        str2double(get(hObject,'String')) returns contents of num_scans as a double

[v,handles]=edit_update(handles,hObject,handles.scans_min,handles.scans_max,handles.scans_default,'%3.0f',1);
handles.scans=v;
% Update handles structure
guidata(hObject, handles);


% --- Executes during object creation, after setting all properties.
function num_scans_CreateFcn(hObject, eventdata, handles)
% hObject    handle to num_scans (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



% --- Executes on button press in disp_deriv.
function disp_deriv_Callback(hObject, eventdata, handles)
% hObject    handle to disp_deriv (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of disp_deriv

if get(hObject,'Value'),
    handles=plot_cw(handles);
    handles=get_characteristics(handles);
    % Update handles structure
    guidata(hObject, handles);
end;

% --- Executes on button press in disp_abs.
function disp_abs_Callback(hObject, eventdata, handles)
% hObject    handle to disp_abs (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of disp_abs

if get(hObject,'Value'),
    handles=plot_integral(handles);
    % Update handles structure
    guidata(hObject, handles);
end;


% --- Executes on button press in disp_doubleintg.
function disp_doubleintg_Callback(hObject, eventdata, handles)
% hObject    handle to disp_doubleintg (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of disp_doubleintg

if get(hObject,'Value'),
    handles=plot_double_integral(handles);
    % Update handles structure
    guidata(hObject, handles);
end;



