function M2=evolve_Bloch(M1,t,w1,WS,T1,T2)
% Evolve magnetization vector M1 for time t (usec), assuming an m.w. field
% amplitude w1 (MHz), an resonance offset WS (MHz), a longitudinal
% relaxation time T1 (usec), and a transverse relaxation time T2 (usec)
% the result is a new magnetization vector M2 

dt=1e-3;
num=t/dt;
Mx=M1(1);
My=M1(2);
Mz=M1(3);
M0=1;

for k=1:num,
    Mx=Mx-dt*2*pi*WS*My-dt*Mx/T2;
    My=My+dt*2*pi*WS*Mx-dt*2*pi*w1*Mz-dt*My/T2;
    Mz=Mz+dt*2*pi*w1*My-dt*(Mz-M0)/T1;
end;
M2=[Mx My Mz];